/*
 * paradlib.cpp - Real hardware OPL connected to a parallel port.
 * Copyright (C) 2005 Raphael Assenat, <raph@raphnet.net> 
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 */

/*
 * Some parts from realopl.cpp (by Simon Peter) 
 * have been reused here.
 */

#include "opl.h"

class CParadlib: public Copl
{
public:
	CParadlib(char *ppdev_dev);
	void write(int reg, int val);

	/* Init the parallel port and adlib card. */
	void init();
	
	/* Call to know if init was ok.
	 * Returns 0 on success, -1 on error. */
	int isInit();

	/* Reset the card. (all instruments off)
	 */
	void reset_card();
private:
	void writeReg(unsigned char reg, unsigned char data);
	void llwrite(unsigned char lsb, unsigned char data, int num_loops);

	
	char *dev;
	int init_res;
	int ppdev_fd;

	static const unsigned char op_table[9];
};

